/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved    */
/* C M P T N O D E . C                                  */

/* THIS PROGRAM BELONGS TO WALTER L. PEACOCK.  IT IS CONSIDERED A TRADE */
/* SECRET AND IS NOT TO BE DIVULGED OR USED BY PARTIES WHO HAVE NOT    */
/* RECEIVED WRITTEN AUTHORIZATION FROM THE OWNER.                   */
/*----------------------------------------------------------------------------
 * cmptnode() is called by btrdelet() when it becomes necessary to compact
 * two index nodes into one node.
 *---------------------------------------------------------------------------*/

#include "cbtree.h"

cmptnode(fddta, fdidx, pblk, btparmst)
int fdidx, fddta;
struct btidxblk *pblk;
struct btcommo *btparmst;
{
   extern long lseek(), poptop();
   extern int  strcmp();
   extern char *calloc(), *strsave();
   extern void free();
   extern int sp;
   long    pblknode, lvlnode, popnode, delloc, lnum, saveloc;
   BTIDXBLK *broblk;
   register int i, j;
   int idxckbro, cmptflag, lk;
   unsigned saveop;
   long pos, bwdptrsv, savlvl;
   char *endbroky, *endidxky;
   int savsp;                   /* stack pointer        */

   i = j = 0;

   /* make buffer to hold index block */
   if( !(broblk = (BTIDXBLK *)calloc(
         sizeof(BTIDXBLK) + btparmst->btcells * sizeof(BTIDX), SZCHAR) ))
      ckerror(- CK_NOMEM, "3");
   broblk->blkalloc = 0;

   if( (delloc = pblk->fwdpage) < 2)   /* check for right brother */
      goto leftbro;

   getidxr(fdidx, pblk->fwdpage, broblk, btparmst->btidxlen,
         btparmst->btkeylen);

   if (broblk->cellicnt > (btparmst->btcells >> 1 ))     /* LC bug */
      /* then too many cells to compact properly.    */
      goto leftbro;

   cmptflag = 1;    /* right compact   */

   /**** combine nodes: append cells from broblk to blkp ****/

   /* # to free to open space for copy */
   j = MIN(broblk->cellicnt, pblk->blkalloc - pblk->cellicnt);
   for (i = 0; i < j; ++i)    /* make room */
   {
      char **cpp;   /* expression too complex for some compilers */

      cpp = &pblk->btpage[pblk->cellicnt + i].skeynme;
      FREE(*cpp);
   }
   pblk->blkalloc -= j;

   /* append page cells from broblk to pblk */
   blkshft(pblk->btpage + pblk->cellicnt, broblk->btpage, broblk->cellicnt,
         SZBTIDX);
   pblk->blkalloc += broblk->cellicnt;
   pblk->cellicnt += broblk->cellicnt;

   /* collapse moved cells in broblk */
   if ((j = broblk->blkalloc - broblk->cellicnt) != 0)  /* # to move */
      blkshft(broblk->btpage, broblk->btpage + broblk->cellicnt, j,
            SZBTIDX);
   broblk->blkalloc = j;
   broblk->cellicnt = 0;

   pblk->fwdpage = broblk->fwdpage;
   pblknode = broblk->bwdpage;

   /* update bwdpage of fwdnode to point to newnode   */

   if(pblk->fwdpage > 1){
      /* locate maint. info.    */
      pos = (pblk->fwdpage - 1L) * btparmst->btidxlen;

      lk = 0;     /* lock the record we are about to modify */
      while (lockunlk(fdidx, pos, btparmst->btidxlen, LOCKR) != 1)
         if (++lk > HDRTRYS){
            freekeys(broblk);
            FREE(broblk);
            return(BTLOCK); /* i.e. unable to lock linked list record */
         }

      /* now position to the backward pointer field of the node.  */
      if (lseek(fdidx, (long) (pos + (2 * sizeof(uword) + sizeof(long)) ),0) == -1L)
         ckerror(- CK_SEEK, "5");

      /* update bwdpage */
      if (write(fdidx, (char *)&pblknode, sizeof(long) ) == ERR)
         ckerror(- CK_WRIT, "6");

      lockunlk(fdidx, pos, btparmst->btidxlen, UNLOCKR);
   }
   goto updtree;

leftbro:
   if( (delloc = pblk->bwdpage) < 2){       /* check for left brother */
      j = BTCALLOK;
      goto freeptrs;   /* must be root node. check on making new node. */
   }

   getidxr(fdidx, pblk->bwdpage, broblk, btparmst->btidxlen, btparmst->btkeylen);

   if (broblk->cellicnt > (btparmst->btcells >> 1) ){
      /* then too many cells to compact properly.    */
      freekeys(broblk);
      FREE(broblk);
      return(-1);
   }

   cmptflag = 0;    /* left compact    */

   /**** merge nodes: insert cells from brother node into pblk ****/

   /* # to free to open space for shift */
   j = MIN(broblk->cellicnt, pblk->blkalloc - pblk->cellicnt);
   for (i = 0; i < j; ++i)    /* make room */
   {
      char **cpp;

      cpp = &pblk->btpage[pblk->cellicnt + i].skeynme;
      FREE(*cpp);
   }
   pblk->blkalloc -= j;

   /* shift cells up to make room for copy */
   blkshft(pblk->btpage + broblk->cellicnt, pblk->btpage, pblk->cellicnt,
         SZBTIDX);

   /* insert cells from broblk to pblk */
   blkshft(pblk->btpage, broblk->btpage, broblk->cellicnt, SZBTIDX);
   pblk->blkalloc += broblk->cellicnt;
   pblk->cellicnt += broblk->cellicnt;

   /* collapse moved cells in broblk */
   if ((j = broblk->blkalloc - broblk->cellicnt) != 0)  /* # to move */
      blkshft(broblk->btpage, broblk->btpage + j, j, SZBTIDX);
   broblk->blkalloc = j;
   broblk->cellicnt = 0;

   pblk->bwdpage = broblk->bwdpage;
   pblknode = broblk->fwdpage;

   /* update fwdpage of bwdnode to point to cmptnode    */

   if(pblk->bwdpage > 1){
      lnum = (long) ((pblk->bwdpage - 1L) * btparmst->btidxlen);

      lk = 0;     /* lock the record we are about to modify */
      while (lockunlk(fdidx, lnum, btparmst->btidxlen, LOCKR) != 1)
         if (++lk > HDRTRYS){
            freekeys(broblk);
            FREE(broblk);
            return(BTLOCK); /* i.e. unable to lock linked list record */
         }

      /* locate maint. info.   */
      /* position to the forward pointer field of the node.  */
      if (lseek(fdidx, (long) (lnum + (2L * sizeof(uword)) ),0) == -1L)
         ckerror(- CK_SEEK, "8");

      /* update bwdpage   */
      if (write(fdidx, (char *)&pblknode, sizeof(long) ) == ERR) 
         ckerror(- CK_WRIT, "9");

      lockunlk(fdidx, lnum, btparmst->btidxlen, UNLOCKR);
   }

updtree:
   putidxr(fdidx, pblknode, pblk, btparmst);

   /* get last keys for both nodes */
   if( !(endbroky = calloc(btparmst->btkeylen + 1, SZCHAR) ))
      ckerror(- CK_NOMEM, "10");
   if( !(endidxky = calloc(btparmst->btkeylen + 1, SZCHAR) ))
      ckerror(- CK_NOMEM, "11");
   strcpy(endbroky, pblk->btpage[pblk->cellicnt - 1].skeynme);
   strcpy(endidxky, endbroky);

   /* delete brother node */
   deletrec(fdidx, delloc, btparmst->btidxlen);
   savlvl = pblknode;

   /* update nodes in upper levels of B+tree */
   if( (lvlnode = popnode = poptop() ) == 0L){
      j = BTCALLOK;
      goto freeptrs;
   }

   savsp = sp;     /* save stack postion   */
   savlvl = popnode;

   /* if right compact, adjust index node end key in upper level */
   if (cmptflag == 1){
      while (popnode != 0L){

         savlvl = popnode;

         getidxr(fdidx, popnode, broblk, btparmst->btidxlen,
               btparmst->btkeylen);

         i = 0;
         while (broblk->btpage[i++].btptr != pblknode){
            if(i >= broblk->cellicnt){
               if ( (popnode = broblk->fwdpage) < 2)
                  ckerror(- CK_INDX, "12");
               else{
                  adjstack(fdidx, broblk, popnode, btparmst);
                  getidxr(fdidx, popnode, broblk, btparmst->btidxlen, btparmst->btkeylen);
                  i = 0;
               }
            }
         }

         strcpy(broblk->btpage[--i].skeynme, endidxky);

         putidxr(fdidx, popnode, broblk, btparmst);

         strcpy(endidxky, broblk->btpage[broblk->cellicnt - 1].skeynme);
         pblknode = popnode;
         popnode = poptop();
      }
   }

   /* back to the parent node */
   getidxr(fdidx, lvlnode, broblk, btparmst->btidxlen, btparmst->btkeylen);

   idxckbro = 0;    /* flag to tell when both brothers have been checked */
   bwdptrsv = broblk->bwdpage;      /* save in case need to get back to bwd*/
   i = 0;

   /* find cell which has been deleted */
   while (broblk->btpage[i].btptr != delloc){
      i++;
      if(i >= broblk->cellicnt){
         if (idxckbro < 2){
            if (idxckbro == 0){
               if ( (savlvl = lvlnode = broblk->fwdpage) > 0){
                  adjstack(fdidx, broblk, lvlnode, btparmst);
                  getidxr(fdidx, lvlnode, broblk, btparmst->btidxlen,
                        btparmst->btkeylen);
                  i = 0;
               }
               else
                  idxckbro = 1;
            }

            if (idxckbro == 1){
               if ( (savlvl = lvlnode = bwdptrsv) > 0){
                  adjstack(fdidx, broblk, lvlnode, btparmst);
                  getidxr(fdidx, lvlnode, broblk, btparmst->btidxlen,
                        btparmst->btkeylen);
                  i = 0;
               }
               else{
                  j = BTCALLOK;
                  goto freeptrs;
               }
            }
            ++idxckbro;
         }
         else{
            j = BTCALLOK;
            goto freeptrs;
         }
      }
   }

   saveloc = btparmst->btloc;
   saveop = btparmst->btoptype;
   btparmst->btloc = 0;
   btparmst->btoptype = DELTKY;

   sp = savsp;     /* restore stack postion   */

   if ( (j = btrdelet(fddta, fdidx, broblk, i, lvlnode, btparmst) ) < 0){
      return(j);
   }

   btparmst->btloc = saveloc;
   btparmst->btoptype = saveop;

freeptrs:
   FREE(endbroky);
   FREE(endidxky);

   if( (pblk->fwdpage < 2) && (pblk->bwdpage < 2) ){

      lvlnode = savlvl;
      adjstack(fdidx, broblk, lvlnode, btparmst);
      getidxr(fdidx, lvlnode, broblk, btparmst->btidxlen, btparmst->btkeylen);

      deletrec(fdidx, btparmst->btroot, btparmst->btidxlen);

      /* make this the new root node.    */

      if (cmptflag == 1)      /* right compact    */
         btparmst->btroot = broblk->btpage[0].btptr;
      else                /* left compact    */
         btparmst->btroot = pblknode;

      putroot(fdidx, btparmst->btroot, btparmst->findroot);
   }

   freekeys(broblk);
   FREE(broblk);
   return( (j == BTCALLOK) ? 1 : -1);
}
